%global npm_name vdhcoapp

Name:           vdhcoapp
Version:        2.0.19
Release:        1.20240314git0b40d3e%{?dist}
Summary:        Video DownloadHelper companion app

License:        GPL2 and MIT and ISC and Apache-2.0 and Unlicense and BSD-2-Clause
URL:            https://github.com/aclap-dev/vdhcoapp
Source0:        %{npm_name}-%{version}.tar.xz
Source1:        %{npm_name}-%{version}-nm-prod.tar.xz
Source2:        %{npm_name}-%{version}-bundled-licenses.txt
Source3:        convert_config.py

# Patches on top of upstream version
Patch0:         0001-app-converter-make-import-of-open-compatible-with-CJ.patch
Patch1:         0002-app-converter-print-error-about-missing-executable-t.patch
Patch2:         0003-app-return-dynamically-computed-target-information.patch
Patch3:         0004-app-manifest-hard-code-the-executable-path.patch
Patch4:         0005-app-converter-patch-the-filepicker-executable-name.patch
Patch5:         0006-app-override-executable-name-in-couple-more-places.patch
Patch6:         0007-app-disable-Flatpak-support-in-install-codepath.patch

BuildArch:      noarch
ExclusiveArch:  %{nodejs_arches} noarch

Requires:       nodejs
Requires:       vdhcoapp-filepicker
Requires:       ffmpeg

BuildRequires:  nodejs-devel
# python is required for config file conversion
BuildRequires:  python >= 3.11

%description
Companion app for Video DownloadHelper browser extension.


%prep
%setup -q -n %{npm_name}-%{version}
%autopatch -p1
cp %{SOURCE2} .
# Setup bundled runtime(prod) node modules
tar xf %{SOURCE1}

%build
# Convert and clean up the config file
%{python3} %{SOURCE3} config.toml config.json

# Create launcher script
cat > vdhcoapp-launcher.sh <<EOF
#!/usr/bin/env bash
export NODE_PATH=%{nodejs_sitelib}/%{npm_name}
node --title=vdhcoapp "%{nodejs_sitelib}/%{npm_name}/main.js" "\$@"
EOF


%install
mkdir -p %{buildroot}%{nodejs_sitelib}/%{npm_name}

# Copy launcher script
install -D -m 0755 vdhcoapp-launcher.sh %{buildroot}%{_bindir}/vdhcoapp

# Copy source scripts
cp -pr app/src/*.js \
    %{buildroot}%{nodejs_sitelib}/%{npm_name}

# Copy config file
cp -pr config.json \
    %{buildroot}%{nodejs_sitelib}/%{npm_name}

# Copy over bundled nodejs modules
cp -pr node_modules \
    %{buildroot}%{nodejs_sitelib}/%{npm_name}


%files
%doc README.md
%license LICENSE.txt %{npm_name}-%{version}-bundled-licenses.txt
%{nodejs_sitelib}/%{npm_name}
%{_bindir}/vdhcoapp


%changelog
* Thu Mar 14 2024 Rok Mandeljc <rok.mandeljc@gmail.com> - 2.0.19-1.20240314git0b40d3e
- Initial packaging attempt
